CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 2
  reps = 4
  bpin =20  'video basepine
  indicator = 3
  strobe = 5

  tsl_clk  = 6
  tsl_si   = 8
  mcp_clk  = 9
  mcp_data = 10
  mcp_cs   = 11
  trigger  = 1          'button in
  channel  = 0    'mcp base channel
  remote  = 4

VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[16]
  long dt
  long ms,range,center,voffset,subtract,t1,maxval,minval,delay,cmd
  word dataL[130],dataR[130]
OBJ
  io    :"FullDuplexSerial"
  tv    : "tv"
  gr    : "graphics2"
  MCP   : "MCP3208_fast_rjo"
  tsl   : "tsl1401asm_rjo_001"
PUB start | i,sample,tester
                                                                             
  'start and setup graphics
  voffset:=10
  InitParams
  gr.start
  io.start(14,15,0,115200)
  ms:=80000
  delay :=0
  voffset:=90
  
  mcp.start(mcp_data,mcp_clk,mcp_cs)
  gr.setup(16, 12, 128, 96, bitmap_base)
  dira[tsl_clk]:=dira[tsl_si]:=dira[strobe]:=dira[indicator]:=1
  tsl.start(@cmd)
  repeat until cmd == 0
  'tester:= long [tsl.init(cmd)]

    
  repeat 
     outa[strobe]:=0
    ' dt:=cnt
     i:=getimage
     'dt:=cnt-dt
     subtractimage
     plot
     if ina[trigger]==1
    
        outa[indicator]:=1                
        sendimage
        outa[indicator]:=0
    
pub sendimage |i
    i:=0
    repeat 256
     io.tx(byte[@datal][i])
     i++
    i:=0
    repeat 256
     io.tx(byte[@datar][i])
     i++
                   
pub getimage | i,tester
 dt:=cnt
 cmd:=1

 repeat until cmd==0
 dt:=cnt-dt
 i:=0
 repeat 128
      outa[tsl_clk]:=1 
      outa[tsl_clk]:=0 
      datar[i]:=(mcp.in(channel+1))
      datal[i]:=(mcp.in(channel))
      i++

Pub SubtractImage | i
 repeat 1
   cmd:=1

   repeat until cmd==0
 i:=0
 repeat 130
      outa[tsl_clk]:=1 
      outa[tsl_clk]:=0 
      datar[i]:=||(datar[i]-(mcp.in(channel+1)))
      datal[i]:=||(datal[i]-(mcp.in(channel)) )
      i++

pub plot  |i, j,jj,k, kk,px,py,dechr

    gr.clear
    gr.colorwidth(3,0)
    gr.box(60,80,60,16)
    gr.colorwidth(2,0 )
    gr.text(64,80,@pchip)
    

    range:=readKnob
    range:=(8000/range )
    if range > 10
       range:=range*2
    gr.colorwidth(2,0)
    repeat i from 0 to 126
      px:=i-128
      py:= ((dataL[i])/range)-voffset
      gr.plot(px,-voffset)
      gr.line(px,py)
      px:=i
      py:= ((dataR[i])/range  )-voffset
      gr.plot(px,-voffset)
      gr.line(px,py)
   
    gr.colorwidth(3,0)
    dechr:="L"
    gr.text(-64,-92,@dechr)
    dechr:="R"
    gr.text(64,-92,@dechr)
    gr.text(-90,80,@maximum)
    plotInt(range,-30,80) 
    gr.text(-120,70,@exp)
    plotint(CLKFREQ/dt,0,70)
    

    gr.color(2)
    gr.colorwidth(2,0)
    gr.copy(display_base)

Pub readKnob

    maxval:=mcp.in(channel+2)
    if maxval//100 > 50
    
      maxval:=maxval/100
    
      maxval:=maxval*100
      maxval:=maxval+50
    else
      maxval:=(maxval/100)*100
    maxval:=maxval + 45
    if maxval > 4095
       maxval := 4095
    return maxval
Pub plotInt (value,x,y) | i,j,k,ii,jj,kk,dechr
    i:=0
    kk:=value
    j:=0
    jj:=kk 
    repeat while kk > 0
         kk:=kk/10
         j++
    j:=j-1
    k:=j   
    kk:=jj
    repeat k   
      repeat j
            kk:=kk/10
      dechr:=num + kk
      gr.text(x+(i*6),y,@dechr)
      repeat j
          kk:=kk*10
      jj:=jj-kk
      kk:=jj
      i++ 
      j:=j-1
    dechr:=num + kk
    gr.text(x+(i*6),y,@dechr)
    gr.color(3)
Pub InitParams   | i,dx,dy

  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)
  repeat i from 0 to 63
    colors[i] := $00001010 * (i+20) & $F + $2B060C02
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)
                             
 

 
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long     (bpin & $38) << 1 | (bpin & 4 == 4) & %0101 
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog
exp                     byte    "Exp Rate(per sec) > ",0
Maximum                 byte    "Pixel Val/ ",0
pchip                   byte    "Propeller",0           'text
num                     byte    "0",0,"1",0,"2",0,"3",0,"4",0,"5",0,"6",0,"7",0,"8",0,"9",0